
;  text und hexadezimaler file viewer
;  coded 1996 by iCode
;  all rights reserved


.386c


code    segment byte use16
        assume  cs:code,ds:code,use16
        org     100h
entry:  jmp     begin


headerline       db 37,'Zeige an :                 Spalte : '
ApiCheck         db 12,'shell system'   ; String fr API-Check
leer             db '      '
file_size        db '            Bytes'
percent_string   db '            '
spalte_string    db '           '

colour1          db 01bh                ; auszugebender Text
colour1a         db 0c1h                ; markierter Text
colour2          db 0b0h                ; Kopfzeile
colour3          db 030h                ; Fuzeile
colour4          db 07fh                ; Farbe fuer Rahmen von Dialog-Boxen
colour5          db 04fh                ; Farbe fr Fehler-Boxen
colour6          db 030h                ; Farbe fuer Optionen in den Dialogboxen
colour7          db 03fh                ; Farbe fuer aktive Optionen in ""
colour8          db 00eh                ; Vordergrund fr Hotkeys in Dialogboxen
colour9          db 020h                ; Farbe fuer Buttons
colour10         db 02fh                ; Farbe fuer aktive Buttons
colour11         db 070h                ; Farbe fr Text in Dialog-Boxen

filename         db 120 dup (0)         ; anzuzeigende Datei
fileSize         dd 0                   ; Gre der Datei
fileHandle       dw 0                   ; Datei-Handle der anzuzeigenden Datei

horizStart       dw 0                   ; Text-Verschiebung nach rechts
startPos         dw 0                   ; Bildschirm-Startpos im Speicher-Puffer
endpos           dw 0                   ; Bildschirm-Endpos im Speicher-Puffer
fileStartpos     dd 0                   ; Puffer-Startpos im File
bufferSize       dw 0                   ; Anzahl der Bytes im Puffer (norm 64k)

mode             db 0                   ; 0=Ascii-Text, 1=Hex
keyMode          db 0h                  ; 0=Smooth, 1=Fast, 2=Bios
return_value     db 00h                 ; haelt 'ERRORLEVEL' einiger Funktionen

F1Text           db 'Help  '
F3aText          db 'Smooth'
F3bText          db 'Fast  '
F3cText          db 'Slow  '
F4aText          db 'Ascii '
F4bText          db 'Hex   '
F5Text           db 'Goto  '
F7Text           db 'Search'
F8Text           db 'Go on '
F10Text          db 'Exit  '

text_seg         dw 0                   ; hlt Ram-Segment fr Puffer

bytes_moved      dw 0

garbage01        dd 0                   ; temporre Variable
garbage02        dw 0                   ; temporre Variable
Choice           db 0                   ; hlt aktives Men-Element

CaseSensity      db 00h                 ; Gro-Klein Suche oder nicht...

OldCurPos        dw 0a16h               ; hlt temporr die Cursor-Position

include asc.inc                         ; enthlt die ASCII-Textausgabe
include hex.inc                         ; enthlt die HEX-Textausgabe
include help.inc                        ; enthlt die Hilfe-Funktionen (F1)
include search.inc                      ; enthlt die Such-Funktionen (F7)
include goto.inc                        ; enthlt die Goto-Funktionen (F5)
include error.inc                       ; enthlt die Fehlerbehandlung

cursorOn proc
        mov cx, 607h
        mov ah, 1
        int 10h
        ret
cursorOn endp

CursorOff proc
        mov     cx, 2000h
        mov     ah,1
        int     10h
        ret
CursorOff endp

PushButton proc                         ; Parameter !
    mov ah, 5
    mov bh, 6
    mov bl, colour10
    int 32h
    ret
PushButton endp

step_forward proc
      pusha
      mov ebx, filesize
      sub ebx, filestartpos
      movzx eax, bufferSize
      sub ebx, eax
      mov dx, 60000
      cmp ebx,10000h
      jae @lb001
      mov dx, bx
    @lb001:
      add dx, 4000
      mov bufferSize, dx           ; Variable updaten
      sub dx, 4000
      mov bytes_moved, dx
  ; Betrag um den verschoben wird, steht jetzt in dx
      mov eax, filestartpos
      movzx ebx, dx
      add eax, ebx
      mov filestartpos, eax
      mov dx, ax
      shr eax, 16
      mov cx, ax
      mov ax, 4200h
      mov bx, fileHandle
      int 21h
      jnc @no_error3
      jmp @error
    @no_error3:
      mov cx, 0ffffh
      mov ah, 03fh
      mov bx, fileHandle
      xor dx, dx
	mov ds, text_seg
      int 21h
      jnc @no_error_50
      jmp @error
    @no_error_50:
	push cs
	pop ds
        mov bufferSize, ax
      popa
      ret
step_forward endp

step_backward        proc
      pusha
      mov eax, filestartpos
      cmp eax, 48000
      ja @springe_zurueck
      mov startpos, ax
      mov bytes_moved, ax
      mov filestartpos, 0
      jmp @Zeiger_updaten
  ; Schritt 2b: 48000 von der fileposition abziehen...
    @Springe_zurueck:
      sub filestartpos, 48000
      add startpos, 48000
      mov bytes_moved, 48000
    @Zeiger_Updaten:
      mov eax, filestartpos
      mov dx, ax
      shr eax, 16
      mov cx, ax
      mov ax, 4200h
      mov bx, fileHandle
      int 21h
      jnc no_error3
      jmp @error
    no_error3:
      mov eax, filesize
      sub eax, fileStartpos
      cmp eax, 0ffffh
      jb gogo
      mov ax, 0ffffh
    gogo:
      mov cx, ax
      mov ah, 03fh
      mov bx, fileHandle
      xor dx, dx
      mov ds, text_seg
      int 21h
      push cs
      pop ds
      mov bufferSize, ax
      popa
      ret
    @go_on_1:
      popa
      mov si, startpos
      call readdata
      ret
step_backward endp

readdata        proc
        pusha
        mov eax, filestartpos
        mov dx, ax
        shr eax, 16
        mov cx, ax
        mov ax, 4200h
        mov bx, fileHandle
        int 21h
        jnc NoSeekError
        jmp @error
  NoSeekError:
        mov eax, filesize
        sub eax, filestartpos
        mov ecx, eax
        cmp eax, 0ffffh
        jb ReadCxBytes
        mov cx, 0ffffh                        ; eine volle Ladung Bytes
      ReadCxBytes:
        mov ah, 03fh                    ; }
        mov bx, fileHandle                  ; }
        xor dx, dx                      ; } blockread(fileHandle, textSeg, MAXIMUM)
        mov ds, text_seg                ; }
        int 21h                         ; }
        jnc NoReadError1
        popa
        add sp, 2
        jmp @error
      NoReadError1:
        push cs
        pop ds
        mov bytes_moved, ax
        mov bufferSize, ax
        popa
        ret
readdata endp

wait_retrace proc
    push ax
    push dx
    mov dx, 03dah
@x: in al, dx
    test al, 08h
    jnz @x
@y: in al, dx
    test al, 08h
    jz @y
    pop dx
    pop ax
    ret
endp



calculate proc
      pusha
 ; 1. Schritt : Startpos + Filestartpos addieren, mit 100 multiplizieren
      mov eax, cs:filestartpos
      xor ebx, ebx
      mov bx, cs:endpos
      add eax, ebx
      xor ebx, ebx
      mov bx, 100
      mul ebx
      ; xor edx, edx
      mov ebx, cs:filesize
      div ebx
      movzx bx, al
      cmp bl, 100
      ja @leave_proc_3
      push es
      push bx

      mov cl, 0
      mov ch, bl
      mov dx, 5046h
      mov bl, colour1
      mov bh, colour2
      mov ah, 10
      int 32h

      xor edx, edx
      pop dx
      mov di, offset percent_string
      xor bl, bl
      mov ax, cs
      mov es, ax
      mov ah, 12
      int 32h

      mov byte ptr [offset percent_string+5], 4
      mov byte ptr [offset percent_string+6], '%'
      mov si, offset percent_string+5
      mov dx, 4100h
      mov bl, cs:colour2
      xor bh, bh
      mov ah, 6
      int 32h
      mov ax, cs
      mov es, ax
      xor dx, dx
      mov bx, cs:horizStart
      mov ah, 12
      mov di, offset spalte_string
      int 32h
      mov dh, 36
      mov dl, 0
      mov bl, cs:colour2
      mov bh, 0
      mov cs:[offset spalte_string+7], 3
      mov si, offset spalte_string+7
      mov ah, 6
      int 32h
      pop es
    @leave_proc_3:
      popa
      ret
endp



put proc                                ; BL=Zahlenwert
  mov bh,bl          ; Kopie -> BH
  shr bl, 4          ; Higher Nibble nach rechts
  and bx,0f0fh       ; Den Rest weg, BH gleich mit in ASCII wandeln und
  add bx, '00'       ; ins Video-RAM schreiben.
  mov al, bl
  mov ah, 70h
  stosw
  mov al, bh
  stosw
  ret
endp


draw_space proc
  mov al, 20h
  stosb
  inc di
  ret
endp





draw_f4_button proc
    mov si, offset f4bText
    mov al, cs:mode
    cmp al, 0
    jne @asdfg
    mov si, offset f4aText
  @asdfg:
    mov bl, cs:colour3
    mov bh, 07h
    mov ax, 0b04h
    int 32h
    ret
endp

draw_f3_button proc
    pusha
    mov si, offset f3aText
    mov al, cs:keyMode
    cmp al, 0
    je @asdfg3
    mov si, offset f3bText
    cmp al, 1
    je @asdfg3
    mov si, offset f3cText
  @asdfg3:
    mov bl, cs:colour3
    mov bh, 07h
    mov ax, 0b03h
    int 32h
    popa
    ret
endp

clearground    proc
        push 0b800h
        pop es
        xor di, di                            ; obere Zeile
        mov cx, 80
        mov ah, colour2
        mov al, 20h
        rep stosw                             ; Bildschirm blau
        mov cx, 1840
        mov ah, colour1
        rep stosw
        mov ax, 0b00h
        mov bl, colour3
        mov bh, 07h
        mov si, offset leer
      @oiu:
        inc al
        int 32h
        cmp al, 10
    jb @oiu
        mov si, offset f1Text
        mov al, 1
        int 32h
        mov si, offset f5Text
        mov al, 5
        int 32h
        call draw_f3_button
        call draw_f4_button
        mov si, offset f10Text
        mov al, 10
        int 32h
        mov si, offset f7Text
        mov al, 7
        int 32h
        mov si, offset f8Text
        mov al, 8
        int 32h

        xor dx, dx
        movzx bx, colour2
        mov si, offset headerline
        mov ah, 6
        int 32h
        call calculate
        ret
clearground endp





clear_buffer proc
    mov ah, 19
    int 32h
    ret
clear_buffer endp


getkey proc
        cmp cs:keyMode, 2
        je getBiosKey
        cmp cs:keyMode, 1
        je getFastkey
        mov ah, 18
        mov al, 2
        int 32h
        ret
    getFastKey:
        mov ah, 18
        mov al, 1
        int 32h
        ret
    getBiosKey:
        mov ah, 1
        int 16h
        jz NoKey
        xor ah, ah
        int 16h
        mov al, ah
        ret
    noKey:
        xor al, al
        ret
getKey endp

checkAPI proc
        xor ah, ah
        int 32h
        mov di, offset ApiCheck
        movzx cx, byte ptr es:[di]
        inc cx
        repe cmpsb
        jcxz @weiter201
        push cs
        pop ds
        jmp @error
      @weiter201:
        push cs
        pop ds
        ret
checkAPI endp




begin:
        mov sp, offset endOfCode + 1010 ; Stackbereich endet jetzt bei 1010
        mov bx, offset endOfCode + 1100 ; Code-Segment verkleinern
        shr     bx, 4
        mov     ah, 4ah                 ; dos-resize-blocklen-call
        int     21h
        jnc     noStackError
        jmp     @error
      nostackError:

        call    checkAPI

        mov     ah, 13                  ; }
        xor     al, al                  ; } Blinken deaktivieren
        int     32h                     ; }

        call cursorOff

;        mov ah, 22
;        int 32h
;        mov cl, byte ptr [si]
;        inc si
;        push cs
;        pop es
;        mov di, offset fileName
;        rep movsb
;        mov byte ptr es:[di], 0
;        push cs
;        pop  ds

        mov si, 80h                     ; bei 80h beginnt Kommandozeile im PSP
        movzx cx, byte ptr [si]         ; Lngenbyte in CX laden
        cmp cl, 1                       ; Kommandozeile leer ??
        ja @weiter18
        jmp @error                      ; kein Argument angegeben ...
      @weiter18:
        mov di, offset filename
        add si, 2
        dec cx
        rep movsb                       ; Filename-String kopieren
        mov byte ptr es:[di], 0         ; ASCIIZ-Nullbyte anfgen

        mov dx, offset filename
        mov cx, 0ffh
        mov ah, 4eh
        int 21h
        mov eax, ds:dword ptr [09ah]
        mov filesize, eax
        mov bx, ax
        shr eax, 16
        mov dx, ax
        mov ah, 12
        mov di, offset file_size
        int 32h

        mov ah, 48h
        mov bx, 4096
        int 21h
        jnc noMemError
        jmp @error
      noMemError:
        mov fs, ax
        mov text_seg, ax

        mov dx, offset filename
        mov ax, 3d00h
        int 21h
        jnc fileOK
        jmp @error
      fileOK:
        mov fileHandle, ax

        call readdata
        call clearground

        mov ah, colour2
        mov di, 22
        mov si, offset filename
        mov al, 27h
        stosw
      @qwqwqw:
        lodsb
        cmp al, 07ah
        ja @lb3
        cmp al, 61h
        jb @lb3
        sub al, 20h
      @lb3:
        cmp al, 0
        je @rt
        stosw
        jmp @qwqwqw
      @rt:
        mov al, 27h
        stosw

        mov byte ptr file_size, 10h
        mov bl, colour2
        mov dx, 3000h
        xor bh, bh
        mov ah, 6
        mov si, offset file_size
        int 32h

    AscLoop:
        call AscBuildFullScreen         ; ASCII-Bildschirm aufbauen
    AscInputLoop:
        call calculate                  ; Prozentbalken ausgeben
        call getkey                     ; Taste

        cmp al, 50h
        jne @pageDown
        call ascDown
        jmp ascInputLoop
      @pageDown:
        cmp al, 51h
        jne @left_arrow
        call asc_scroll_page_down
        jmp ascInputLoop
      @left_arrow:
        cmp al, 4bh
        jne @right_arrow
        call shift_screen_left
        jmp ascInputLoop
      @right_arrow:
        cmp al, 4dh
        jne @asc_pos1
        call shift_screen_right
        jmp ascInputLoop
      @asc_pos1:
        cmp al, 47h
        jne @up_arrow
        call jump_to_begin
        call AscBuildFullScreen
        jmp ascInputLoop
      @up_arrow:
        cmp al, 48h
        jne @asc_f10
        call AscUp
        jmp ascInputLoop
      @asc_f10:
        cmp al, 68
        jne @ascF1
        jmp @ende
      @ascF1:
        cmp al, 3bh
        jne @asc_F3
        xor ax, ax
        call help
        jmp ascInputLoop
      @asc_f3:
        cmp al, 3dh
        jne @asc_f4
        call clear_buffer
        inc keyMode
        cmp keyMode, 3
        jb $+7
        mov keyMode, 0
        call draw_f3_button
        mov ah, 24
        int 32h
        jmp ascInputLoop
      @asc_f4:
        cmp al, 3eh
        jne AscF5
        mov mode, 1
        call draw_f4_button
        mov ah, 24
        int 32h
        jmp hexLoop
      AscF5:
        cmp al, 3fh
        jne @asc_f7
        call GotoOffset
        jmp ascInputLoop
      @asc_f7:
        cmp al, 41h
        jne @asc_f8
        call SearchText
        jmp ascInputLoop
      @asc_f8:
        cmp al, 42h
        jne @end
        call searchOn
        jmp ascInputLoop
      @end:
        cmp al, 4fh
        jne @asc_page_up
        call AscEnd
        jmp ascInputLoop
      @asc_page_up:
        cmp al, 49h
        jne @asc_esc
        call AscPageUp
        jmp ascInputLoop
      @asc_esc:
        cmp al, 01h
        je @12212
        jmp ascInputLoop
      @12212:
        jmp @ende

      hexLoop:
        call hexBuildFullScreen
      hexInputLoop:
        call calculate
      @hex_no_change:
        call getkey
      @hex_down_arrow:
        cmp al, 50h
        jne @hex_page_down
        call HexDown
        jmp hexInputLoop
      @hex_page_down:
        cmp al, 51h
        jne @hex_pos1
        call hex_scroll_page_down
        jmp hexInputLoop
      @hex_pos1:
        cmp al, 47h
        jne @hex_up_arrow
        call jump_to_begin
        call hexBuildfullScreen
        jmp hexInputLoop
      @hex_up_arrow:
        cmp al, 48h
        jne @hex_end
        call HexUp
        jmp hexInputLoop
      @hex_end:
        cmp al, 4fh
        jne @hex_f10
        call HexEnd
        jmp hexInputLoop
      @hex_f10:
        cmp al, 44h
        jne @hexF1
        jmp @ende
      @hexF1:
        cmp al, 3bh
        jne @hex_F3
        mov ax, 100h
        call help
        jmp hexInputLoop
      @hex_f3:
        cmp al, 3dh
        jne @hex_f4
        call clear_buffer
        inc keyMode
        cmp keyMode, 3
        jb $+7
        mov keyMode, 0
        call draw_f3_button
        mov ah, 24
        int 32h
        jmp hexInputLoop
      @hex_f4:
        cmp al, 3eh
        jne hexF5
        mov mode, 0
        call draw_f4_button
        mov si, startpos
        call ascSearchlastline
        mov startpos, si
        mov ah, 24
        int 32h
        jmp ascLoop
      hexF5:
        cmp al, 3fh
        jne @hexPageUp
        call gotoOffset
        jmp hexInputLoop
      @hexPageUp:
        cmp al, 49h
        jne @hex_esc
        call hex_scroll_page_up
        jmp hexInputLoop
      @hex_esc:
        cmp al, 01h
        je @ende
        jmp hexInputLoop

      @ende:
        call clear_buffer
        call cursorOn
        mov ah, 4ch
        int 21h


@error:
    push ds
    mov dx, offset error0
    push cs
    pop ds
    mov ah,9
    int 21h
    pop ds
    jmp @ende
    error0 db ' Allgemeiner Fehler !',13,10,'$'

endOfCode    equ     this byte

code    ends
        end     entry



